### Foreground Color ###

# 文字色をcolorで指定された色に変更する
function term_fg_color(color) {
	if (color == "black") {
		printf "\033[30m"
	} else if (color == "red") {
		printf "\033[31m"
	} else if (color == "green") {
		printf "\033[32m"
	} else if (color == "yellow") {
		printf "\033[33m"
	} else if (color == "blue") {
		printf "\033[34m"
	} else if (color == "magenta") {
		printf "\033[35m"
	} else if (color == "cyan") {
		printf "\033[36m"
	} else if (color == "white") {
		printf "\033[37m"
	}
	return
}


### Background Color ###

# 背景色をcolorで指定された色に変更する
function term_bg_color(color) {
	if (color == "black") {
		printf "\033[40m"
	} else if (color == "red") {
		printf "\033[41m"
	} else if (color == "green") {
		printf "\033[42m"
	} else if (color == "yellow") {
		printf "\033[43m"
	} else if (color == "blue") {
		printf "\033[44m"
	} else if (color == "magenta") {
		printf "\033[45m"
	} else if (color == "cyan") {
		printf "\033[46m"
	} else if (color == "white") {
		printf "\033[47m"
	}
	return
}


### Attribute ###

# 文字を太字にする
function term_bold() {
	printf "\033[01m"
}

# 文字色と背景色を反転する
function term_reverse() {
	printf "\033[07m"
}

# 文字の属性(色や太字など)をリセットする
function term_atr_reset() {
	printf "\033[00m"
}


### Cursor Move ###

# カーソルをn行上に移動する
function term_cursor_up(n) {
	printf "\033[%dA", n
}

# カーソルをn行下に移動する
function term_cursor_down(n) {
	printf "\033[%dB", n
}

# カーソルをn桁左に移動する
function term_cursor_left(n) {
	printf "\033[%dD", n
}

# カーソルをn桁右に移動する
function term_cursor_right(n) {
	printf "\033[%dC", n
}

# カーソルをrow行目のcol桁目に移動する
function term_cursor_move(row, col) {
	printf "\033[%d;%dH", row, col
}


### Cursor Control ###

# カーソルを非表示にする
function term_hidden_cursor() {
	printf "\033[>5h"
}

# カーソルを表示する
function term_show_cursor() {
	printf "\033[>5l"
}


### Key Input ###

# キー入力を1文字読み込む
function term_getkey(    key) {
	"dd bs=1 count=1 2>/dev/null" | getline key
	close("dd bs=1 count=1 2>/dev/null")
	return  key
}


### Miscellaneous ###

# 画面を消去する
function term_clear() {
	printf "\033[2J"
}

function term_init() {
	system("stty raw -echo")
	term_clear()
	term_cursor_move(1, 1)
}

function term_finish() {
	term_atr_reset()
	system("stty cooked echo")
}
